/* +------------------------------------------------+
   |		      PUISSANCE 4                   |
   |                                                |
   |  Auteur : BOCQUENET Jean-Philippe              |
   |  Date : le 2/II/1992.                          |
   |  Langage : Turbo C de Borland Int.             |
   +------------------------------------------------+ */

#include <DOS.H>
#include <BIOS.H>
#include <CONIO.H>
#include <STDLIB.H>

extern int _wscroll = 0;  /* empche le dfilement de l'cran */

#define ENTER         0x1C0D
#define ESC           0x011B
#define FL_GAUCHE     0x4B00
#define FL_DROITE     0x4D00
#define TOUCH1        0x3B00
#define TOUCH2        0x3C00
#define TOUCH3        0x3D00
#define VIDE          0
#define PLEIN         1

int depart = 1; int tot; int coljoueur = 1; int colbyte = 1;
int val[7]; int tableau[8][8];
int testniv = 1; int testjou = 1;
int valeur1 =   2; int valeur2 = 180; int valeur3 =  15;
int val_1 = 2; int val_2 = 180; int val_3 = 15; /* niveau amateur */
int val_4 = 3; int val_5 = 500; int val_6 = 50; /* niveau experiment */

char *pion [2] = {"",
		  ""};

char buffer[4000];
char buffet2[800];

void joueur();
void ordinat();

/* ------------------------------------------ */
void test_ESC()
{ int tce;
  do {tce = bioskey(0);} while (!(tce == ESC));
}

/* ------------------------------------------ */
void ouvre_fenetre(int x1,int y1,int x2,int y2,char color)
{
  gettext(x1,y1,x2,y2,buffer);
  window(x1,y1,x2,y2);
  textbackground(color); clrscr();
}

/* ------------------------------------------ */
void ferme_fenetre(int x1,int y1,int x2,int y2,char color)
{
  window(x1,y1,x2,y2); textbackground(color); clrscr();
  window(1,1,80,25); puttext(x1,y1,x2,y2,buffer);
}

/* ------------------------------------------ */
void rectangle(int type,int x1,int y1,int x2,int y2,\
				     char coul_fond,char coul_car)
{
    int comptx1=x1; int compty1=y1;

    textcolor(coul_car);
    if (type == PLEIN) 
    { window(x1,y1,x2,y2);
      textbackground(coul_fond); clrscr();
      window(1,1,80,25); 
    }

    gotoxy(x1,y1); cprintf(""); 
    gotoxy(x1,y2); cprintf("");
    for (comptx1 += 1; comptx1 < x2 ; comptx1++)
     { gotoxy(comptx1,y1); cprintf("");
       gotoxy(comptx1,y2); cprintf(""); }

    gotoxy(x2,y1); cprintf(""); 
    gotoxy(x2,y2); cprintf("");
    for (compty1 += 1; compty1 < y2 ; compty1++)
     { gotoxy(x1,compty1); cprintf("");
       gotoxy(x2,compty1); cprintf(""); }
}

/* ------------------------------------------ */
void jeux()
{
  unsigned int choix;

  textbackground(BLUE);
  for(;;)
  {choix = bioskey(0);
   switch(choix)
   {case TOUCH1 :    
			textcolor(WHITE);
			if (testniv == 0)
			{ testniv = 1;
			  gotoxy(39,12); cprintf("Amateur    ");
			  valeur1 = val_1; valeur2 = val_2;
			  valeur3 = val_3;
			}
			else
			{ testniv = 0;
			  gotoxy(39,12); cprintf("Expriment");
			  valeur1 = val_4; valeur2 = val_5;
			  valeur3 = val_6;
			}
			break;

    case TOUCH2 :    
			textcolor(WHITE);
			if (testjou == 0)
			{ testjou = 1;
			  gotoxy(43,13); cprintf("Vous      ");
			}
			else
			{ testjou = 0;
			  gotoxy(43,13); cprintf("Ordinateur");
			}
			break;

    case ENTER  :
    case TOUCH3 :    
			ferme_fenetre(11,5,70,23,BLACK);
			if (testjou == 1)
			  { for (;;) { joueur(); } }
			else
			  { for(;;) { depart = 1; ordinat(); } }

    case ESC    :    
			_setcursortype(_NORMALCURSOR);
			textbackground(BLACK); textcolor(LIGHTGRAY);
			normvideo(); clrscr(); exit(0);

    default     :    	break;
   }
  }
}

/* ------------------------------------------ */
void dessin_tableau()
{
  int bcl1; int bcl2; int bcl;
  depart = 1; tot = 0;
  coljoueur = 1;
  for (bcl1=0;bcl1<=7;bcl1++)
    { for (bcl2=0;bcl2<=6;bcl2++)
      { tableau[bcl2][bcl1] = 0; } 
    }
  for (bcl=1;bcl<=7;bcl++) 
    { tableau[7][bcl] = 1; val[bcl] = 0; }
  textbackground(BLACK); textcolor(BLUE); clrscr();
  gotoxy(11, 6); cprintf(" ͻ ");
  gotoxy(11, 7); cprintf("   ۺ                                             ");
  gotoxy(11, 8); cprintf("   ۺ                                             ");
  gotoxy(11, 9); cprintf(" ޱ͹۱ ");
  gotoxy(11,10); cprintf("   ۺ                                             ");
  gotoxy(11,11); cprintf("   ۺ                                             ");
  gotoxy(11,12); cprintf(" ޱ͹۱ ");
  gotoxy(11,13); cprintf("   ۺ                                             ");
  gotoxy(11,14); cprintf("   ۺ                                             ");
  gotoxy(11,15); cprintf(" ޱ͹۱ ");
  gotoxy(11,16); cprintf("   ۺ                                             ");
  gotoxy(11,17); cprintf("   ۺ                                             ");
  gotoxy(11,18); cprintf(" ޱ͹۱ ");
  gotoxy(11,19); cprintf("   ۺ                                             ");
  gotoxy(11,20); cprintf("   ۺ                                             ");
  gotoxy(11,21); cprintf(" ޱ͹۱ ");
  gotoxy(11,22); cprintf(" ްۺ                                          ۰ ");
  gotoxy(11,23); cprintf("߰ۺ                                          ۰");
  gotoxy(11,24); cprintf("");

  rectangle(VIDE,1,1,80,25,BLACK,BLUE);
  rectangle(PLEIN,31,1,50,3,MAGENTA,LIGHTRED);
  textcolor(YELLOW);
  gotoxy(35,2); cprintf("PUISSANCE IV");
  rectangle(PLEIN, 2,3,10,20,LIGHTGRAY,BLUE);
  rectangle(PLEIN,71,3,79,20,LIGHTGRAY,BLUE);
  textcolor(RED);
  gotoxy( 4,17); cprintf("%s",pion[0]);
  gotoxy( 4,18); cprintf("%s",pion[1]);
  textcolor(YELLOW);
  gotoxy(73,17); cprintf("%s",pion[0]);
  gotoxy(73,18); cprintf("%s",pion[1]);
  textcolor(BLACK);
  gotoxy( 3,5);  cprintf(".BYTE.");
  gotoxy( 3,8);  cprintf("Colonne");
  gotoxy(72,5);  cprintf("Joueur");
  gotoxy(72,8);  cprintf("Colonne");
  gotoxy(72,10); cprintf("Deplace");
  gotoxy(72,11); cprintf("colonne");
  gotoxy(72,12); cprintf(" <- -> ");
  gotoxy(72,14); cprintf("Valide:");
  gotoxy(72,15); cprintf("[ENTER]");
  textbackground(BLUE); textcolor(LIGHTRED);
  gotoxy(33,24); cprintf("DRYADES Freeware");
}

/* ------------------------------------------ */
void choix_jeu(int niv, int jou)
{
  int p; int pa;

  highvideo();
  gettext(11,5,70,23,buffer);
  for (p=0;p<=8;p++)
   {rectangle(PLEIN,39-p,13-p,42+p,15+p,BLUE,CYAN);}
  for (pa=1;pa<=16;pa+=5)
   {rectangle(PLEIN,31-pa,5,50+pa,23,BLUE,CYAN); delay(20);}
  rectangle(PLEIN,11,5,70,23,BLUE,CYAN);
  textcolor(CYAN); gotoxy(38, 6); cprintf("MENU");
  textcolor(LIGHTRED);
  gotoxy(14, 8); cprintf("[F.1] Choix du niveau.");
  gotoxy(14,10); cprintf("[F.2] Choix du 1er  jouer.");
  gotoxy(43, 8); cprintf("[F.3] Commencer la partie.");
  gotoxy(43,10); cprintf("[ESC] Sortie du jeu.");
  textcolor(WHITE);
  gotoxy(30,12);
  if (niv == 1) {cprintf("NIVEAU : Amateur");}
  else { cprintf("NIVEAU : Expriment");}
  gotoxy(30,13);
  if (jou == 1) {cprintf("1er JOUEUR : Vous");}
  else { cprintf("1er JOUEUR : Ordinateur");}
  textcolor(CYAN);
  gotoxy(18,15); cprintf("Le jeu  consiste    aligner  horizontalement,");
  gotoxy(18,16); cprintf("verticalement,  ou  en  oblique,  4  pions  de");
  gotoxy(18,17); cprintf("la  mme  couleur.  Les  pions  jaunes  appar-");
  gotoxy(18,18); cprintf("tiennent au joueur, les rouges  l'ordinateur.");
  rectangle(PLEIN,20,19,61,22,MAGENTA,LIGHTRED);
  gotoxy(40,20); cprintf("Auteur");
  gotoxy(31,21); cprintf("Jean-Philippe BOCQUENET");
}

/* ------------------------------------------ */
void chute_pion(int valeur, int colonne)
{
  int ch = 0; int ych= 4;
  int colon = 11+(colonne)*7;

  if (valeur == 1) { textcolor(YELLOW); }
  if (valeur == 5) { textcolor(RED); }

  while (tableau[ch+1][colonne] == 0)
  {
    ch=ch+1;
    gotoxy(colon,ych);   cprintf("    ");
    gotoxy(colon,ych+1); cprintf("%s",pion[0]);
    delay(25);
    gotoxy(colon,ych+1); cprintf("    ");
    gotoxy(colon,ych+3); cprintf("%s",pion[1]);
    delay(25);
    gotoxy(colon,ych+3); cprintf("%s",pion[0]);
    gotoxy(colon,ych+4); cprintf("%s",pion[1]);
    sound((400+(colonne*50))+(ch*10));
    sound(600+(ch*10));
    ych=ych+3;
    delay(55);
    nosound();
  }
    tableau[ch][colonne] = valeur;
}

/* ------------------------------------------ */
void saisie_colonne()
{
  unsigned int touche;

  textcolor(YELLOW);
  gotoxy(11+(coljoueur*7),4); cprintf("%s",pion[0]);
  gotoxy(11+(coljoueur*7),5); cprintf("%s",pion[1]);

  for(;;)
  { touche = bioskey(0);
    switch(touche)
    {
     case FL_GAUCHE : 
	gotoxy(11+(coljoueur*7),4); cprintf("    ");
	gotoxy(11+(coljoueur*7),5); cprintf("    ");
	coljoueur = coljoueur - 1;
	if (coljoueur <= 1) { coljoueur = 1;}
	sound(400+(coljoueur*50));
	gotoxy(11+(coljoueur*7),4); cprintf("%s",pion[0]);
	gotoxy(11+(coljoueur*7),5); cprintf("%s",pion[1]);
	textbackground(LIGHTGRAY); textcolor(BLACK);
	gotoxy(75,9); cprintf("%d",coljoueur);
	textbackground(BLACK); textcolor(YELLOW);
	delay(30);
	nosound();
	break;

     case FL_DROITE : 
	gotoxy(11+(coljoueur*7),4); cprintf("    ");
	gotoxy(11+(coljoueur*7),5); cprintf("    ");
	coljoueur = coljoueur + 1;
	if (coljoueur >= 7) {coljoueur = 7;}
	sound(400+(coljoueur*50));
	gotoxy(11+(coljoueur*7),4); cprintf("%s",pion[0]);
	gotoxy(11+(coljoueur*7),5); cprintf("%s",pion[1]);
	textbackground(LIGHTGRAY); textcolor(BLACK);
	gotoxy(75,9); cprintf("%d",coljoueur);
	textbackground(BLACK); textcolor(YELLOW);
	delay(30);
	nosound();
	break;

     case ENTER     : 
	if (tableau[1][coljoueur] != 0)
	 {  ouvre_fenetre(20,10,61,14,RED);
	    rectangle(PLEIN,20,10,61,14,RED,YELLOW);
	    textcolor(YELLOW);
	    gotoxy(26,12);
	    cprintf("Colonne pleine, rejouez S.V.P.");
	    gotoxy(49,14); cprintf("[Echap/ESC]");
	    test_ESC();
	    ferme_fenetre(20,10,61,14,BLACK);
	    break;
	 }
	else
	 {  chute_pion(1,coljoueur);
	    return;
	 }

     default        : break;
    }
  }
}

/* ------------------------------------------ */
void gagne(int gagnant)
{
  int n; int lon; int p;
  int y = 3; int fin = 9;

  if (gagnant == 3)
  { for (n=1;n<=7;n++)
    {if (tableau[1][n] == 0) {return;} } 
  }

  ouvre_fenetre(11,1,70,24,BLACK);
  textcolor(BLUE); for(lon=2;lon<=79;lon++)
		     { gotoxy(lon,1); cprintf(""); }

  if (gagnant == 1)
  {
    rectangle(PLEIN,16,3,65,9,GREEN,YELLOW);
    textcolor(YELLOW);
    gotoxy(21,4); cprintf("BRAVO MEC !!! !   Vous  avez gagn !! !");
    gotoxy(21,5); cprintf("Vous  venez  d'aligner  4  pions  jaune");
    gotoxy(21,6); cprintf("dans  la grille.  Mais peut tre est-ce");
    gotoxy(21,7); cprintf("un hasard ? Je propose une autre partie");
    gotoxy(21,8); cprintf("pour voir. qu'en dite vous,  on essai ?");
    gotoxy(54,9); cprintf("[Echap/ESC]");
  }

  if (gagnant == 2)
  {
    rectangle(PLEIN,16,3,65,9,RED,LIGHTRED);
    gotoxy(20,4); cprintf("J'AI GAGNE !!! !  I'AM VERY HAPPY !!!! !");
    gotoxy(20,5); cprintf("Je  suis  dsol  pour  vous,  je  viens");
    gotoxy(20,6); cprintf("d'aligner  mes  4  pions rouge  dans  la");
    gotoxy(20,7); cprintf("grille. Je vous propose une autre partie");
    gotoxy(20,8); cprintf("Juste pour se faire la main .... OK ?...");
    gotoxy(54,9); cprintf("[Echap/ESC]");
  }  

  if (gagnant == 3)
  {
    rectangle(PLEIN,16,3,65,10,MAGENTA,LIGHTRED);
    gotoxy(20,4); cprintf("      P A R T I E    N U L L E");
    gotoxy(20,5); cprintf("La partie est nulle on viens  de  remplir");
    gotoxy(20,6); cprintf("la grille sans russir  aligner  4 pions");
    gotoxy(20,7); cprintf("Vous n'tes pas si mauvais que  a finale-");
    gotoxy(20,8); cprintf("ment. Bon faudrait voir  nous dpartager.");
    gotoxy(20,9); cprintf("On va s'en refaire une autre pour voir ?..");
    gotoxy(54,10); cprintf("[Echap/ESC]");
    fin = 10;
  }  

  gettext(16,2,65,fin,buffet2);
  while (y<=26-fin)     
   { puttext(16,y,65,y+(fin-2),buffet2);
     y++;
     delay(70);
   }
  for(p=730;p<=800;p++)
  { sound(p); sound(p-600); delay(10); nosound(); }
  test_ESC();
  ferme_fenetre(11,1,70,24,BLACK);
  textcolor(LIGHTRED + BLINK); 
  gotoxy(36,5); cprintf("[Echap/ESC]");
  test_ESC();
  textbackground(BLACK); dessin_tableau();
  if (gagnant == 1 || gagnant == 2)
  {  choix_jeu(testniv,testjou); jeux(); }
  else {
	 if (testjou == 1) { for (;;) { joueur(); } }
	 else { for (;;) { depart = 1; ordinat(); } }
       }
}

/* ------------------------------------------ */
void niveau1(int colonne, int intermed, int total)
{
 if (total == 1 || total == 5) 
   {val[colonne+intermed] = val[colonne+intermed]+1;}
 if (total == 2)  {val[colonne+intermed] += 3;}
 if (total == 10) {val[colonne+intermed] += valeur1;}
 if (total == 15) {val[colonne+intermed] += valeur2;}
 if (total == 3)  {val[colonne+intermed] = 170;}
}

/* ------------------------------------------ */
void niveau2(int colonne, int intermed, int total)
{
 if (total == 3)  {val[colonne+intermed] -= 20;}
 if (total == 15) {val[colonne+intermed] -= valeur3;}
 if (total == 2 || total == 10) {val[colonne+intermed] += 1;}
}

/* ------------------------------------------ */
void calcul_poids()
{
int col; int col1; int col3; int col5;
int lig; int lig1; int lig3; int lig5;
int inter; int inter1; int inter2; int inter3;
int inter4; int inter5; int inter6;

/* --------------- Verticales --------------- */
  for (col=1;col<=7;col++)
  { for (lig=1;lig<=3;lig++)
    { tot=0;
      for (inter=1;inter<=lig+3;inter++)
      { tot=tot+tableau[inter][col];}
      if (tot ==  4) { gagne(1); }
      if (tot == 20) { gagne(2); }
      if (tot ==  1) { val[col] += 1; }    
      if (tot ==  2) { val[col] += 3; }
      if (tot ==  3) { val[col] = 170; }
      if (tot ==  5) { val[col] += 1; }
      if (tot == 10) { val[col] += 3; }
      if (tot == 15) { val[col] = 220; }
    }
  }
/* ------------- Horizontales --------------- */
  for (col1=1;col1<=4;col1++)
  { for (lig1=1;lig1<=6;lig1++)
    { tot=0;
      for (inter1=0;inter1<=3;inter1++)
      { tot=tot+tableau[lig1][col1+inter1];}
      if (tot ==  4) { gagne(1); }
      if (tot == 20) { gagne(2); }
	for (inter2=0;inter2<=3;inter2++)
	{ if (tableau[lig1][col1+inter2] == 0)
	  { if (tableau[lig1+1][col1+inter2] == 0)  
	    { if (tableau[lig1+2][col1+inter2] != 0)
	      { niveau2(col1,inter2,tot); }
	    }
	    else { niveau1(col1,inter2,tot);}
	  }
	}
    }
  }
/* ---------- Obliques ascendantes ---------- */
  for (col3=1;col3<=4;col3++)
  { for (lig3=4;lig3<=6;lig3++)
    { tot=0;
      for (inter3=0;inter3<=3;inter3++)
      { tot=tot+tableau[lig3-inter3][col3+inter3];}
      if (tot ==  4) { gagne(1); }
      if (tot == 20) { gagne(2); }
      for (inter4=0;inter4<=3;inter4++)
      { if (tableau[lig3-inter4][col3+inter4] == 0)
	{ if (tableau[lig3-inter4+1][col3+inter4] != 0) 
	  { niveau1(col3,inter4,tot); }
	  if (tableau[lig3-inter4+2][col3+inter4] != 0) 
	  { niveau2(col3,inter4,tot); }
	}
      }
    }
  }
/* ---------- Obliques descendantes ---------- */
  for (col5=1;col5<=4;col5++)
  { for (lig5=1;lig5<=3;lig5++)
    { tot=0;
      for (inter5=0;inter5<=3;inter5++)
      { tot=tot+tableau[lig5+inter5][col5+inter5];}
      if (tot ==  4) { gagne(1); }
      if (tot == 20) { gagne(2); }
      for (inter6=0;inter6<=3;inter6++)
      { if (tableau[lig5+inter6][col5+inter6] == 0)
	{ if (tableau[lig5+inter6+1][col5+inter6] != 0)
	  { niveau1(col5,inter6,tot); }
	  if (tableau[lig5+inter6+2][col5+inter6] != 0)
	  { niveau2(col5,inter6,tot); }
	}
      }
    }
  }
}

/* ------------------------------------------ */
void joueur()
{
  depart = 0;
  calcul_poids();
  gagne(3);
  saisie_colonne();
  ordinat();
}

/* ------------------------------------------ */
void ordinat()
{
  int valtamp = 0;
  int tes; int bcl;

  for (bcl=1;bcl<=7;bcl++)
  { val[bcl] = 60; 
    if (tableau[1][bcl] != 0) { val[bcl] = -900; } }
      calcul_poids();
      gagne(3);
      if (depart == 1)  { colbyte = rand() % 8; 
			  if (colbyte <= 1) 
			    { colbyte = 1; } 
			}
      else
      { valtamp = -700;
	for(tes=1;tes<=7;tes++)
	  { if (val[tes] >= valtamp) 
	     { valtamp = val[tes]; colbyte = tes; }
	    if (val[tes] == valtamp)
	     { colbyte = tes; }
	  }
       }
      textbackground(LIGHTGRAY); textcolor(BLACK);
      gotoxy(6,9); cprintf("%d",colbyte);
      textbackground(BLACK);
      depart = 0;
      chute_pion(5,colbyte);
      joueur();
}

/* ------------------------------------------ */
void main(void)
{
  enable();
  _setcursortype(_NOCURSOR);
  dessin_tableau();
  choix_jeu(testniv,testjou);
  jeux();
}
